/**********************************************************************
 *
 *   FreeDoko a Doppelkopf-Game
 *    
 *   Copyright (C) 2001-2004  by Diether Knof and Borg Enders
 *
 *   This program is free software; you can redistribute it and/or 
 *   modify it under the terms of the GNU General Public License as 
 *   published by the Free Software Foundation; either version 2 of 
 *   the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details. 
 *   You can find this license in the file 'gpl.txt'.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 *   MA  02111-1307  USA
 *
 *  Contact:
 *    Diether Knof dknof@gmx.de
 *    Borg Enders  borg@borgsoft.de
 *
 **********************************************************************/

#ifdef USE_UI_GTK
#ifndef GTK_ICONGROUP_HEADER
#define GTK_ICONGROUP_HEADER

#include "pixmap.h"

#include "htin.h"

namespace GTK_DOKO {
#include <gtk/gtkwidget.h>

  // the icongroup of a player
  class IconGroup : public HTINBase {
    public:
      // constructor
      IconGroup(class IconGroups* icongroups,
		Player const& player);

      // the icongroups 
      IconGroups& icongroups();

      // starting x-position (border to the hand)
      int border_x();
      // starting y-position (border to the hand)
      int border_y();
      // starting x-position of the team
      int team_start_x(Pixmap const& pixmap);
      // starting y-position of the team
      int team_start_y(Pixmap const& pixmap);
      // starting x-position of the announcement
      int announcement_start_x(Pixmap const& pixmap);
      // starting y-position of the announcement
      int announcement_start_y(Pixmap const& pixmap);
      // starting x-position of the swines and hyperswines
      int swines_start_x(Pixmap const& pixmap);
      // starting y-position of the swines and hyperswines
      int swines_start_y(Pixmap const& pixmap);

      // width of the icongroup
      unsigned width();
      // height of the icongroup
      unsigned height();

      // draws the icons of player in the pixmap
      void draw(bool const update = true);
      // draws the team (or gametype for the soloplayer)
      void team_draw(bool const update = true);
      // draws the announcement
      void announcement_draw(bool const update = true);
      // draws the swines and hyperswines
      void swines_draw(bool const update = true);

    private: // not to be used
      IconGroup();
      IconGroup(const IconGroup&);
      IconGroup& operator=(const IconGroup&);
  }; // class IconGroup : public HTINBase 


  // all icongroups of the players
  class IconGroups : public HTINBaseGroup {
    public:
      // constructor -- set the table
      IconGroups(class Table* table);

      // the icongroup of the player
      IconGroup& icongroup(Player const& player);

    private: // not to be used
      IconGroups();
      IconGroups(const IconGroups&);
      IconGroups& operator=(const IconGroups&);
  }; // class IconGroups : public HTINBaseGroup

} // namespace GTK_DOKO

#endif // #ifndef GTK_ICONGROUP_HEADER
#endif // #ifdef USE_UI_GTK
